#include <stdio.h>
#include <stdlib.h>

int main()
{
    int n;
    scanf("%d", &n);
    int o, a, b, ab;
    scanf("%d%d%d%d", &o, &a, &b, &ab);
    char g[n];
    int p[n];
    for (int i=0; i<n; i++)
        scanf(" %c %d", g+i, p+i);
    int o1=0, a1=0, b1=0;
    static int m[10000][4];


    for (int i=0; i<n; i++)
        if (g[i]=='O')
            o1+=p[i];
    if (o1>o)
    {
        printf("nemoguce");
        return 0;
    }
    for (int i=0; i<n; i++)
        if (g[i]=='O')
            m[i][0]=p[i];
    o-=o1;
    for (int i=0; i<n; i++)
        if (g[i]=='A')
            a1+=p[i];
    if (a1>a+o)
    {
        printf("nemoguce");
        return 0;
    }
    for (int i=0; i<n; i++)
        if (g[i]=='A')
            for (int j=0; j<p[i]; j++)
                if (a)
                {
                    a--;
                    m[i][1]++;
                }
                else
                {
                    o--;
                    m[i][0]++;
                }

    for (int i=0; i<n; i++)
        if (g[i]=='B')
            b1+=p[i];
    if (b1>b+o)
    {
        printf("nemoguce");
        return 0;
    }
    for (int i=0; i<n; i++)
        if (g[i]=='B')
            for (int j=0; j<p[i]; j++)
                if (b)
                {
                    b--;
                    m[i][2]++;
                }
                else
                {
                    o--;
                    m[i][0]++;
                }
    printf("moguce\n");
    for (int i=0; i<n; i++)
    {
        for (int j=0; j<4; j++)
            printf("%d ", m[i][j]);
        printf("\n");
    }
    return 0;
}